<script setup lang="ts">
import { ref, onMounted, watch } from "vue";
import { useCounterMixin } from "@/stores/mixin";
import http from "@/plugins/http";
import config from "@/app.config";
import { useBrrowDataStore } from "@/modules/07_insignia/storeBrrow";

import DialogForm from "@/modules/07_insignia/components/5_Borrow/DialogForm.vue";

import type { OptionDataYear } from "@/modules/07_insignia/interface/index/Main";
import type { QTableProps, QInput } from "quasar";
import { useQuasar } from "quasar";

const DataStore = useBrrowDataStore();
const mixin = useCounterMixin();
const { showLoader, hideLoader, messageError } = mixin;
const $q = useQuasar();
const tab = ref<string>("");

const selectRound = ref<string>();
const selectRoundOption = ref<OptionDataYear[]>([]);
const selectRoundAllOption = ref<OptionDataYear[]>([]);

const modal = ref<boolean>(false);
const action = ref<string>("");
const profileId = ref<string>("");
const roundYear = ref<any>();
const insigniaList = ref<any>([]);
const loadView = ref<boolean>(false);

onMounted(async () => {
  await fecthRound();
  // await fecthInsigniaType();
});
const fecthRound = async () => {
  showLoader();
  await http
    .get(config.API.noteround())
    .then(async (res) => {
      let data = res.data.result;
      if (data.length !== 0) {
        selectRoundAllOption.value = [
          {
            name: "ทั้งหมด",
            id: "0",
            year: 0,
          },
        ];
        data.map((e: any) => {
          selectRoundOption.value.push({
            name: "รอบการเสนอขอพระราชทานเครื่องราชปี" + "  " + (e.year + 543),
            id: e.id,
            year: e.year,
          });
          selectRoundAllOption.value.push({
            name: "รอบการเสนอขอพระราชทานเครื่องราชปี" + "  " + (e.year + 543),
            id: e.id,
            year: e.year,
          });
        });

        selectRound.value = data[0].id;
        yearRound.value = data[0].year;
        roundYear.value = data[0].year;
        if (roundYear.value) {
          await fecthInsigniaType();
        }
      }
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
};

const fecthInsignia = async () => {
  await http
    .get(config.API.insignia)
    .then((res) => {
      let data = res.data.result;
      DataStore.fetchDataInsignia(data);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(async () => {
      insigniaList.value = await DataStore.insigniaOp.filter(
        (x: any) => x.type == tab.value || x.type == ""
      );
    });
};

const fecthInsigniaType = async () => {
  await http(config.API.insigniaType)
    .then(async (res) => {
      let data = res.data.result;
      DataStore.fetchDatainsigniaType(data);
      tab.value = DataStore.insigniaType[0].name;
      loadView.value = true;
      await fecthInsignia();
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {});
};

const visibleColumns = ref<String[]>([
  "no",
  "status",
  "citizenId",
  "name",
  "type",
  "employeeType",
  "date",
  "volumeNo",
  "section",
  "dateReceive",
  "page",
  "number",
  "vatnumber",
  "datepay",
  "typepay",
  "address",
  "borrowOrganization",
  "borrowDate",
  "returnOrganization",
  "returnDate",
  "returnReason",
  "action",
]);
const columns = ref<QTableProps["columns"]>([
  {
    name: "no",
    align: "left",
    label: "ลำดับ",
    field: "no",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "citizenId",
    align: "left",
    label: "เลขประจำตัวประชาชน",
    field: "citizenId",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "name",
    align: "left",
    label: "ชื่อ - สกุล",
    field: "name",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "employeeType",
    align: "left",
    label: "สถานภาพ",
    field: "employeeType",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "type",
    align: "left",
    label: "ประเภทเครื่องราชฯ",
    field: "type",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "dateReceive",
    align: "left",
    label: "วันที่ได้รับพระราชทาน",
    field: "dateReceive",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },

  {
    name: "date",
    align: "left",
    label: "วันที่ในราชกิจนุเบกษา",
    field: "date",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "volumeNo",
    align: "left",
    label: "เล่มที่ในราชกิจนุเบกษา",
    field: "volumeNo",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "section",
    align: "left",
    label: "ตอนที่ในราชกิจนุเบกษา",
    field: "section",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "page",
    align: "left",
    label: "หน้าในราชกิจนุเบกษา",
    field: "page",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "number",
    align: "left",
    label: "ลำดับที่ในราชกิจจานุเบกษา",
    field: "number",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "vatnumber",
    align: "left",
    label: "หมายเลขใบกำกับ",
    field: "vatnumber",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "datepay",
    align: "left",
    label: "วันที่จ่ายใบกำกับฯ",
    field: "datepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "typepay",
    align: "left",
    label: "รูปแบบการจ่าย",
    field: "typepay",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "address",
    align: "left",
    label: "ที่อยู่ที่จ่าย",
    field: "address",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "borrowOrganization",
    align: "left",
    label: "หน่วยงานที่ยืม",
    field: "borrowOrganization",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "borrowDate",
    align: "left",
    label: "วันที่ยืม",
    field: "borrowDate",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "returnOrganization",
    align: "left",
    label: "หน่วยงานที่คืน",
    field: "returnOrganization",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "returnDate",
    align: "left",
    label: "วันที่คืน",
    field: "returnDate",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "returnReason",
    align: "left",
    label: "เหตุผลการคืน",
    field: "returnReason",
    sortable: true,
    sort: (a: string, b: string) =>
      a.localeCompare(b, undefined, { numeric: true, sensitivity: "base" }),
  },
  {
    name: "action",
    align: "left",
    label: "",
    field: "",
  },
]);

watch(tab, async () => {
  insigniaList.value = await DataStore.insigniaOp.filter(
    (x: any) => x.type == tab.value || x.type == ""
  );
  DataStore.insignia = "";
  fecthlistInsignia();
});

const yearRound = ref<number>();
const selectorRound = async (round: number) => {
  roundYear.value = round;
  await fecthlistInsignia();
};
const fecthlistInsignia = async () => {
  showLoader();
  await http
    .get(
      config.API.insigniaManageBorrowList(Number(roundYear.value), tab.value)
    )
    .then(async (res) => {
      await DataStore.fetchlistinsignia(res.data.result);
    })
    .catch((err) => {
      messageError($q, err);
    })
    .finally(() => {
      hideLoader();
    });
};

const filterRef = ref<QInput>();
const filter = ref<string>("");

const close = () => {
  modal.value = false;
};

const closeAndFecth = () => {
  modal.value = false;
  fecthlistInsignia();
};

const addData = () => {
  modal.value = true;
  action.value = "addData";
};

const editData = (id: any) => {
  profileId.value = id;
  action.value = "editData";
  modal.value = true;
};

const resetFilter = () => {
  // reset ค่าที่ค้นหาเมื่อกดปุ่ม X ในกล่องค้นหา
  filter.value = "";
  filterRef.value!.focus();
};
const pagination = ref({
  sortBy: "name",
  descending: false,
  page: 1,
  rowsPerPage: 10,
});
const paging = ref<boolean>(true);
const paginationLabel = (start: number, end: number, total: number) => {
  if (paging.value == true) return " " + start + "-" + end + " ใน " + total;
  else return start + "-" + end + " ใน " + total;
};
</script>

<template>
  <div class="toptitle text-dark col-12 row items-center">
    ยืม-คืนเครื่องราชฯ
  </div>
  <q-card
    flat
    bordered
    class="col-12 q-my-md q-mt-sm rounded-borders"
    v-if="loadView == true"
  >
    <q-tabs
      dense
      v-model="tab"
      align="left"
      class="bg-white text-grey"
      active-color="primary"
      indicator-color="primary"
    >
      <div v-for="item in DataStore.insigniaType">
        <q-tab :name="item.name" :label="item.label" />
      </div>
    </q-tabs>
    <q-separator />
    <q-tab-panels v-model="tab" animated>
      <q-tab-panel
        v-for="item in DataStore.insigniaType"
        :key="item.name"
        :name="item.name"
        class="q-pa-none"
      >
        <div class="q-pa-md">
          <div class="row col-12 q-pb-sm q-col-gutter-x-xs">
            <div>
              <q-select
                v-model="yearRound"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'รอบการเสนอขอเครื่องราชฯ'}`"
                emit-value
                map-options
                option-label="name"
                :options="selectRoundAllOption"
                option-value="year"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="selectorRound"
              />
            </div>
            <div>
              <q-select
                v-model="DataStore.insignia"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'เครื่องราชฯ'}`"
                emit-value
                map-options
                option-label="name"
                :options="insigniaList"
                option-value="id"
                :readonly="false"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="
                  DataStore.searchDatatable(
                    DataStore.insignia,
                    DataStore.employeeClass
                  )
                "
              />
            </div>
            <div>
              <q-select
                v-model="DataStore.employeeClass"
                dense
                outlined
                lazy-rules
                hide-bottom-space
                :label="`${'สถานภาพ'}`"
                emit-value
                map-options
                option-label="name"
                :options="DataStore.employeeClassOps"
                option-value="id"
                :readonly="false"
                :borderless="false"
                style="min-width: 150px"
                @update:model-value="
                  DataStore.searchDatatable(
                    DataStore.insignia,
                    DataStore.employeeClass
                  )
                "
              />
            </div>

            <div>
              <q-btn
                @click="addData()"
                size="12px"
                flat
                round
                color="add"
                icon="mdi-plus"
              >
                <q-tooltip>เพิ่ม</q-tooltip>
              </q-btn>
            </div>
            <q-space />

            <div class="items-center" style="display: flex">
              <!-- ค้นหาข้อความใน table -->
              <q-input
                standout
                dense
                v-model="filter"
                ref="filterRef"
                outlined
                debounce="300"
                placeholder="ค้นหา"
                style="max-width: 200px"
                class="q-ml-sm"
              >
                <template v-slot:append>
                  <q-icon v-if="filter == ''" name="search" />
                  <q-icon
                    v-if="filter !== ''"
                    name="clear"
                    class="cursor-pointer"
                    @click="resetFilter"
                  />
                </template>
              </q-input>
              <!-- แสดงคอลัมน์ใน table -->
              <q-select
                v-model="visibleColumns"
                :display-value="$q.lang.table.columns"
                multiple
                outlined
                dense
                :options="columns"
                options-dense
                option-value="name"
                map-options
                emit-value
                style="min-width: 150px"
                class="gt-xs q-ml-sm"
              />
            </div>
          </div>
          <d-table
            :rows="DataStore.rows"
            :columns="columns"
            :visible-columns="visibleColumns"
            :filter="filter"
            row-key="name"
            :pagination-label="paginationLabel"
            v-model:pagination="pagination"
          >
            <template v-slot:body-cell="props">
              <q-td :props="props">
                <div v-if="props.col.name == 'no'">
                  {{ props.rowIndex + 1 }}
                </div>

                <div
                  v-else-if="
                    props.col.name == 'action' && props.row.returnDate == '-'
                  "
                >
                  <q-td>
                    <q-btn
                      label="คืนเครื่องราชฯ"
                      @click="editData(props.row.id)"
                      color="blue"
                    />
                  </q-td>
                </div>

                <div v-else>
                  {{ props.value }}
                </div>
              </q-td>
            </template>
          </d-table>
        </div>
      </q-tab-panel>
    </q-tab-panels>

    <DialogForm
      :modal="modal"
      :close="close"
      :close-and-fecth="closeAndFecth"
      :round-id="selectRound == '0' ? 'all' : selectRound"
      :action="action"
      :profile-id="profileId"
      :select-round-option="selectRoundOption"
      :type-id="tab"
    />
  </q-card>
  <q-card v-else>
    <div class="q-pa-md q-gutter-sm">
      <q-banner inline-actions rounded class="bg-grey-1 text-center">
        ไม่มีข้อมูลรอบการเสนอขอพระราชทานเครื่องราชอิสริยาภรณ์
      </q-banner>
    </div>
  </q-card>
</template>
<style lang="scss" scoped>
.arrow {
  transition: transform 0.5s;
}

.arrow-active {
  transition: transform 0.5s;
  transform: rotate(-90deg);
}

.bg-base {
  background-color: #f3f3f398;
}

.v-enter-active,
.v-leave-active {
  transition: opacity 0.5s ease;
}

.v-enter-from,
.v-leave-to {
  opacity: 0;
}

.flexsave {
  display: flex;
  justify-content: flex-end;
}
</style>
